/*  dc fighting v0.1.5: relative rotation(dodging)

 by
 jimbo
 Dan Potter and Jordan DeLong of Cryptic Allusion
 Andrew K.
 Marcus Comstedt
*/




/*** Dan Potter's code in macro form ***/
/* This weird logic is to avoid bouncing back
   and forth before the user lets go of the
   button. */
#define PRESSED( x, y ) if (!(cond.buttons & x )) { \
	if (!(y & 0x1000)) {

#define PRESSED2( x, y, z ) if (  (!(cond.buttons & x)) && \
          (!(cond.buttons & y)) ) { if (!(z & 0x1000)) {

#define DESSERP( y ) if (y == 0) y = 0x1001; else y = 0x1000; } }




/*** play the CPU ***/
void random_input( fighter_t *p ) {
  int choice = rand() % 15;

  if ( p->fighting_state <= FIGHT_STAND )
  if ( p->lists_in_future == 0 )
  switch( choice ) {
    
    /*** jab ***/
  case 0:
    p->default_state = FIGHT_MOVE;
    add_anchor( p, 0.07, jab_out, FIGHT_PUNCH );
    add_anchor( p, 0.07, left_fighting_stance, FIGHT_STAND );
    break;

  case 1:
    p->default_state = FIGHT_MOVE;
    /***round house ***/
    add_anchor( p, 0.2, round_kick_outside, FIGHT_MOVE );
    add_anchor( p, 0.02, round_kick_connect2, FIGHT_KICK );
    add_anchor( p, 0.25, left_fighting_stance, FIGHT_STAND );
    break;

  default: break;
  }


 

}



/*** try again - not being such a smartass with the logic ***/
void process_input2( fighter_t *p, cont_cond_t cond ) {
  int hit_a_and_x = 0;
  float control_invert = 1.0;
  

  /*** v0.1.5: control inversion a little hacky for now ***/
  if ( p == player2 ) { control_invert = -1.0; }

    /*** already doing a move ***/
    if ( p->lists_in_future > 0 ) { return; }



    /*** motion ***/
    if ( fighting_distance > minimum_fighting_distance ) 
      if (!(cond.buttons & CONT_DPAD_RIGHT)) {
	fighting_distance -= 0.03 * control_invert;
	/*** v0.1.5: strafe - reset rotation ***/
	( (fighter_t*)(p->opponent) )->params[ROTATION_OPPONENT] = 0.0;
	/*** v0.1.5: change global displacement ***/
	fighting_displacement[0] += 0.03;
    }

    if (!(cond.buttons & CONT_DPAD_LEFT)) {
      fighting_distance += 0.03 * control_invert;
	/*** v0.1.5: strafe - reset rotation ***/
	( (fighter_t*)(p->opponent) )->params[ROTATION_OPPONENT] = 0.0;
	/*** v0.1.5: change global displacement ***/
	fighting_displacement[0] -= 0.03;
    }

    /* v0.1.5: relative rotation: this is crucial, this is where the sidestep happens.
     *   rotate the world around the fighters, and
     *    rotate them around their centers
     */
    if (!(cond.buttons & CONT_DPAD_UP)) {
      p->params[ ROTATION_OPPONENT ] -= 0.05 * control_invert / fighting_distance;
      fighting_rotation += 0.05 * control_invert / fighting_distance;
	/*** v0.1.5: strafe - reset rotation ***/
	( (fighter_t*)(p->opponent) )->params[ROTATION_OPPONENT] = 0.0;
	/*** v0.1.5: change global displacement ***/
	fighting_displacement[1] += 0.03;
    }
    if (!(cond.buttons & CONT_DPAD_DOWN)) {
      p->params[ ROTATION_OPPONENT ] += 0.05 * control_invert / fighting_distance;
      fighting_rotation -= 0.05 * control_invert / fighting_distance;
	/*** v0.1.5: strafe - reset rotation ***/
	( (fighter_t*)(p->opponent) )->params[ROTATION_OPPONENT] = 0.0;
	/*** v0.1.5: change global displacement ***/
	fighting_displacement[1] -= 0.03;
    }



    if ( ( cond.rtrig > 0 ) && ( cond.ltrig > 0 ) ){


      /* Analog stick here :
       *  hold both triggers for free rotate
       */
      view_rot += (float)( cond.joyx - 128 ) * 0.001;
      view_roty += (float)( cond.joyy - 128 ) * 0.001;
      printf("rotation %f %f\n", 
	     player1->params[ ROTATION_OPPONENT ],
	     player2->params[ ROTATION_OPPONENT ] );

    }  /*** holding both triggers ***/





    /* A + X Buttons : reverse stance
     *
     *
     */
    PRESSED2( CONT_A, CONT_X, p->transab )

      /*** so we can tell later ***/
      hit_a_and_x = 1;

        p->default_state = FIGHT_MOVE;
        p->fighting_state = FIGHT_MOVE;

	/*** A+B: reverse stance ***/
	p->reverse = 1 - p->reverse;
	add_anchor( p, 0.15, left_fighting_stance, FIGHT_STAND );
  
    DESSERP(  p->transab )
    /*** not A&B ***/
    else {
      p->transab &= ~0x1000;
    }



    /* B button: jab, quick shot
     *
     *
     *
     */
    PRESSED( CONT_B, p->transb )
      printf("jab %d\n",p->reverse);
      p->default_state = FIGHT_MOVE;
    
      add_anchor( p, 0.07, jab_out, FIGHT_PUNCH );
      add_anchor( p, 0.1, left_fighting_stance, FIGHT_STAND );
    
    DESSERP( p->transb ) 
    /*** B was not pressed ***/
    else {
      p->transb &= ~0x1000;
    }
      


    /*** check for X+A - dont add another punch ***/    
if( hit_a_and_x == 0 ) {

    /* A button: defense
     *  - parry/counter with a direction
     *  - block with pad neutral
     */
     PRESSED( CONT_A, p->transa )

       p->default_state = FIGHT_MOVE;

       /*** DownA - parry/counter ***/
       if (!(cond.buttons & CONT_DPAD_DOWN)) {
	 add_anchor( p, 0.07, arms_crossed, FIGHT_COUNTER );
	 add_anchor( p, 0.15, left_fighting_stance, FIGHT_STAND );
	 
       }
       /*** UpA standing up w/arms crossed ***/
       else if (!(cond.buttons & CONT_DPAD_UP)) {
	 add_anchor( p, 0.15, arms_crossed, FIGHT_STAND );
       }
       /*** A : block ***/
       else {
	 add_anchor( p, 0.15, blocking, FIGHT_BLOCK );
	 p->default_state = FIGHT_BLOCK;
       }
       
     DESSERP( p->transa )
     /*** A was not pressed ***/
     else {
       
       // ?
       p->default_state = FIGHT_STAND;
       
       /*** logic applied to detect A button release ***/
       if ( p->transa >= 0x1000 ) {
	 add_anchor( p, 0.2, left_fighting_stance, FIGHT_STAND );
	 p->default_state = FIGHT_STAND;
       }
       p->transa &= ~0x1000;
     }



    
    /* X button: reverse attack
     * - check direction for modifiers
     *    block, parry, counter...
     *
     */
    PRESSED( CONT_X, p->transx )

        p->default_state = FIGHT_MOVE;

	/*** RightX - hook ***/
	if (!(cond.buttons & CONT_DPAD_RIGHT)) {
	  
	  add_anchor( p, 0.13, punch_windup, FIGHT_MOVE );
	  add_anchor( p, 0.13, reverse_out, FIGHT_PUNCH );
	  add_anchor( p, 0.2, left_fighting_stance, FIGHT_STAND );
	}
	/*** DownX - two hand push ***/
	else if (!(cond.buttons & CONT_DPAD_DOWN)) {
	  
	  add_anchor( p, 0.4, twohand_chamber, FIGHT_MOVE );
	  add_anchor( p, 0.15, twohand_push, FIGHT_PUNCH );
	  add_anchor( p, 0.3, left_fighting_stance, FIGHT_STAND );
	}
        /*** LeftX - elbow ***/
	else if (!(cond.buttons & CONT_DPAD_LEFT)) {
	  
	  add_anchor( p, 0.2, twohand_chamber, FIGHT_MOVE );
	  add_anchor( p, 0.1, elbow_connect2, FIGHT_PUNCH );
	  add_anchor( p, 0.25, left_fighting_stance, FIGHT_STAND );
	}



        /*** no direction - regular reverse punch ***/
	else {
	  add_anchor( p, 0.05, left_fighting_stance, FIGHT_MOVE );
	  add_anchor( p, 0.10, reverse_out, FIGHT_PUNCH );
	  add_anchor( p, 0.23, left_fighting_stance, FIGHT_STAND );
	}


    DESSERP( p->transx )
    /*** X was not pressed ***/
    else {
      p->transx &= ~0x1000;
    }



} /*** no X+A combo ***/


    /* Y button - kicks
     *
     */
    PRESSED( CONT_Y, p->transy )
      
        p->default_state = FIGHT_MOVE;
    
       /*** RightY - round house ***/
       if (!(cond.buttons & CONT_DPAD_RIGHT)) {
	 add_anchor( p, 0.2, round_kick_outside, FIGHT_MOVE );
	 add_anchor( p, 0.02, round_kick_connect2, FIGHT_KICK );
	 add_anchor( p, 0.25, left_fighting_stance, FIGHT_STAND );
       }
       /*** DownY - knee ***/
       else if (!(cond.buttons & CONT_DPAD_DOWN)) {
	 add_anchor( p, 0.2, knee_connect, FIGHT_KICK );
	 add_anchor( p, 0.2, left_fighting_stance, FIGHT_STAND );
       }
       /*** LeftY - side kick ***/
       else if (!(cond.buttons & CONT_DPAD_LEFT)) {
	 add_anchor( p, 0.2, sidekick_chamber, FIGHT_MOVE );
	 add_anchor( p, 0.1, sidekick_connect, FIGHT_KICK );
	 add_anchor( p, 0.2, sidekick_chamber, FIGHT_MOVE );
	 add_anchor( p, 0.2, left_fighting_stance, FIGHT_STAND );
       }
       /*** Y - short kick ***/
       else {
	 add_anchor( p, 0.1, jabkick_out, FIGHT_KICK );
	 add_anchor( p, 0.2, left_fighting_stance, FIGHT_STAND );
       }
       

     DESSERP( p->transy )
       /*** Y was not pressed ***/
     else {
       p->transy &= ~0x1000;
     }
    











}



	 
/* Input loop :
 *  - designed to work with two controllers (parameters)
 *  - depends on globals 
 *        chosen_param, p->params[],  parameter_names[] );
 *
 */
void process_input( fighter_t *p, cont_cond_t cond ) {
  /* for later:
     cond_t cond = p->controller;
  */

  /* Conditional loop: check for moves here,
       block if style.

       A:   block
       B:   jab
       X:   reverse punch
       Y:   kick
       A+B: switch stance
       Y+B: variable speed move

   */
 


  //  printf( "%d\n", p->fighting_state );


  /*** if state is staggering, cant do shit ***/
  // if ( p->fighting_state < FIGHT_STUNNED ) { return; }










    /* Hold L and R triggers to enter parameter-manip debug mode:
     *  - up/down(discrete) changes index
     *  - left/right(hold) changes value
     *
     */
    if ( ( cond.rtrig > 0 ) && ( cond.ltrig > 0 ) ){
   



#if 0
	  printf("r ==%f %f %f  == theta      target == %f  state == %d\n",
		 p->params[0],
		 p->params[1],
		 p->params[2],
		 p->params[7],
		 p->fighting_state
		 );
#endif



      /* Directional Pad
       *
       *
       */
      if (!(cond.buttons & CONT_DPAD_UP)) {
	/* This weird logic is to avoid bouncing back
	   and forth before the user lets go of the
	   button. */
	if (!(p->trans & 0x1000)) {
	  if ( chosen_param < NUMBER_PARAMETERS ) chosen_param++; 
	  printf("%d: %f    %s\n", 
		 chosen_param, 
		 p->params[chosen_param],  
		 parameter_names[chosen_param] );
	  //  printf(" %d %d     %d %d\n", cond.joyx, cond.joyy, cond.joy2x, cond.joy2y );
	  
	  if (p->trans == 0)
	    p->trans = 0x1001;
	  else
	    p->trans = 0x1000;
	}
	
      } else {
	p->trans &= ~0x1000;
      }
      
      
    

      if (!(cond.buttons & CONT_DPAD_DOWN)) {
	/* This weird logic is to avoid bouncing back
	   and forth before the user lets go of the
	   button. */
	if (!(p->trans2 & 0x1000)) {

	  /* WHY IS IT that the dreamcast crashes here
	   *   on the printf after changing chosen_param ?
	   *   stack space considerations: give each array twice the
	   *   size of NUMBER_PARAMETERS.
	   */
	  printf("uhuhuh%d: %f    %s\n", 
		 chosen_param,  
		 p->params[chosen_param],  
		 parameter_names[chosen_param] );
	  if ( chosen_param > 0 ) {
	    chosen_param--;
	  }
	  printf("%d: %f\n", chosen_param,  p->params[chosen_param] );


	  if (p->trans2 == 0)
	    p->trans2 = 0x1001;
	  else
	    p->trans2 = 0x1000;
	}
	
      } else {
	p->trans2 &= ~0x1000;
      }
      

      if (!(cond.buttons & CONT_DPAD_LEFT)) {
	p->params[chosen_param] += 0.05;
      }
     
      if (!(cond.buttons & CONT_DPAD_RIGHT)) {
	p->params[chosen_param] -= 0.05;
      }
      

      /* Analog stick here :
       *  hold both triggers for free rotate
       */
      view_rot += (float)( cond.joyx - 128 ) * 0.001;
      view_roty += (float)( cond.joyy - 128 ) * 0.001;
  

    }  /*** holding both triggers ***/







    /* Right Trigger:  clear out future.
     *  pressing the right trigger  will
     *   clear out the cached future moves, allowing new ones to be put in.
     *
     */
    else if ( cond.rtrig > 0 ) { 
      int i;
      /* This weird logic is to avoid bouncing back
	 and forth before the user lets go of the
	 button. */
      if (!(p->transrtrig & 0x1000)) {
	for ( i=0; i<FUTURE_SIZE; i++ ) {
	  p->future_lists[0][i] = 0.0;
	}
	if (p->transrtrig == 0)
	  p->transrtrig = 0x1001;
	else
	  p->transrtrig = 0x1000;
      }




    } 
    else {
      p->transrtrig &= ~0x1000;
    }
    
    /* Up, Down, Left, Right - move in space
     *
     */
    if (!(cond.buttons & CONT_DPAD_RIGHT)) {
      p->params[ 0 ] -= 0.05;
    }
    if (!(cond.buttons & CONT_DPAD_LEFT)) {
      p->params[ 0 ] += 0.05;
    }
    if (!(cond.buttons & CONT_DPAD_UP)) {
       p->params[ 2 ] += 0.05;
    }
    if (!(cond.buttons & CONT_DPAD_DOWN)) {
       p->params[ 2 ] -= 0.05;
    }







    /* Buttons ABXY below
     *  all input is coded for here.
     *  facilitated with a macro to check the move history buffer.
     *
     *  all controller input subtleties will stem directly from logic below.
     *  logic is central here.
     * 
     *
     *

     if ( A+B ) {}
     else if ( Y+B ) {}
     else {
       if ( Y ) {}
       if ( B ) {}
       if ( A ) {}
     }
     if( X ) {}
       

     // due to 'else' constraints from the switching logic
     //  nesting could get deep
     ////////////////////////////////
     if ( A+B ) {}
     else {
       if ( Y+B ) {}
       else {
         if ( Y ) {}
	 if ( B ) {}
	 if ( A ) {}
       }
     }
     if( X ) {}
  

     *
     *
     *
     *******************************************************************/



    /*** already doing a move ***/
    if ( p->lists_in_future > 0 ) { return; }







    /* A + B Buttons : reverse stance
     *
     *
     */
    PRESSED2( CONT_A, CONT_B, p->transab )

        p->default_state = FIGHT_MOVE;
        p->fighting_state = FIGHT_MOVE;

	/*** A+B: reverse stance ***/
	p->reverse = 1 - p->reverse;
	add_anchor( p, 0.15, left_fighting_stance, FIGHT_STAND );
  
    DESSERP(  p->transab )
    /*** not A&B ***/
    else {
      p->transab &= ~0x1000;
    





      /* Y+B combo: do move with trigger-speed
       *
       *
       */
      PRESSED2( CONT_Y, CONT_B, p->transyb )

          p->default_state = FIGHT_MOVE;

	  /*** set trigger->quickness sensitivity here ***/
	  float timing = (float)( 285 - cond.ltrig ) / (float)384;
      
          add_anchor( p, timing, reverse_out, FIGHT_PUNCH );
	  add_anchor( p, timing, left_fighting_stance, FIGHT_STAND );
    
      DESSERP( p->transyb ) 
      /*** not A+B, not Y+B ***/
      else {
        p->transyb &= ~0x1000;
    




    
	/* B button: jab, quick shot
	 *
	 *
	 *
	 */
        PRESSED( CONT_B, p->transb )
	  printf("jab %d\n",p->reverse);
            p->default_state = FIGHT_MOVE;

	    add_anchor( p, 0.07, jab_out, FIGHT_PUNCH );
            add_anchor( p, 0.07, left_fighting_stance, FIGHT_STAND );
	  
        DESSERP( p->transb ) 
	/*** B was not pressed ***/
	else {
	  p->transb &= ~0x1000;
        }
      





        /* Y button - kicks
	 *
         */
         PRESSED( CONT_Y, p->transy )

             p->default_state = FIGHT_MOVE;

	     /*** RightY - round house ***/
	     if (!(cond.buttons & CONT_DPAD_RIGHT)) {
	       add_anchor( p, 0.2, round_kick_outside, FIGHT_MOVE );
	       add_anchor( p, 0.02, round_kick_connect2, FIGHT_KICK );
	       add_anchor( p, 0.25, left_fighting_stance, FIGHT_STAND );
	     }
 	     /*** DownY - knee ***/
	     else if (!(cond.buttons & CONT_DPAD_DOWN)) {
	       add_anchor( p, 0.2, knee_connect, FIGHT_KICK );
	       add_anchor( p, 0.2, left_fighting_stance, FIGHT_STAND );
	     }
  	     /*** LeftY - side kick ***/
	     else if (!(cond.buttons & CONT_DPAD_LEFT)) {
	       add_anchor( p, 0.2, sidekick_chamber, FIGHT_MOVE );
	       add_anchor( p, 0.1, sidekick_connect, FIGHT_KICK );
	       add_anchor( p, 0.2, sidekick_chamber, FIGHT_MOVE );
	       add_anchor( p, 0.2, left_fighting_stance, FIGHT_STAND );
	     }
  	     /*** Y - short kick ***/
	     else {
	       add_anchor( p, 0.1, jabkick_out, FIGHT_KICK );
	       add_anchor( p, 0.2, left_fighting_stance, FIGHT_STAND );
	     }


         DESSERP( p->transy )
         /*** Y was not pressed ***/
         else {
	   p->transy &= ~0x1000;
         }
      



        /* A button: defense
	 *  - parry/counter with a direction
	 *  - block with pad neutral
	 */
        PRESSED( CONT_A, p->transa )

	    p->default_state = FIGHT_MOVE;

	    /*** DownA - parry/counter ***/
	    if (!(cond.buttons & CONT_DPAD_DOWN)) {
	      add_anchor( p, 0.01, arms_crossed, FIGHT_COUNTER );
	      add_anchor( p, 0.3, left_fighting_stance, FIGHT_STAND );
	      
	    }
	    /*** UpA standing up w/arms crossed ***/
	    else if (!(cond.buttons & CONT_DPAD_UP)) {
	      add_anchor( p, 0.15, arms_crossed, FIGHT_STAND );
 	    }
	    /*** A : block ***/
	    else {
	      add_anchor( p, 0.15, blocking, FIGHT_BLOCK );
	      p->default_state = FIGHT_BLOCK;
	    }
	
	DESSERP( p->transa )
        /*** A was not pressed ***/
	else {

	  // ?
	  p->default_state = FIGHT_STAND;

	  /*** logic applied to detect A button release ***/
	  if ( p->transa >= 0x1000 ) {
	    add_anchor( p, 0.2, left_fighting_stance, FIGHT_STAND );
	    p->default_state = FIGHT_STAND;
	  }
	  p->transa &= ~0x1000;
	}
      




      }  /*** no A+B or Y+B combo(else-if chain) ***/








    }  /*** not A&B pressed***/






    
    /* X button: reverse attack
     * - check direction for modifiers
     *    block, parry, counter...
     *
     */
    PRESSED( CONT_X, p->transx )

        p->default_state = FIGHT_MOVE;

	/*** RightX - hook ***/
	if (!(cond.buttons & CONT_DPAD_RIGHT)) {
	  
	  add_anchor( p, 0.1, punch_windup, FIGHT_MOVE );
	  add_anchor( p, 0.1, reverse_out, FIGHT_PUNCH );
	  add_anchor( p, 0.2, left_fighting_stance, FIGHT_STAND );
	}
	/*** DownX - two hand push ***/
	else if (!(cond.buttons & CONT_DPAD_DOWN)) {
	  
	  add_anchor( p, 0.3, twohand_chamber, FIGHT_MOVE );
	  add_anchor( p, 0.15, twohand_push, FIGHT_PUNCH );
	  add_anchor( p, 0.3, left_fighting_stance, FIGHT_STAND );
	}
        /*** LeftX - elbow ***/
	else if (!(cond.buttons & CONT_DPAD_LEFT)) {
	  
	  add_anchor( p, 0.1, elbow_connect2, FIGHT_PUNCH );
	  add_anchor( p, 0.2, left_fighting_stance, FIGHT_STAND );
	}



        /*** no direction - regular reverse punch ***/
	else {
	  add_anchor( p, 0.1, reverse_out, FIGHT_PUNCH );
	  add_anchor( p, 0.18, left_fighting_stance, FIGHT_STAND );
	}


    DESSERP( p->transx )
    /*** X was not pressed ***/
    else {
      p->transx &= ~0x1000;
    }





    
}  /*** end controller function ***/
